<template>
  <h1>Translations</h1>

  <div class="_filters">
    <div class="_filters__section">
      <label for="selected_locale" class="_filters__section__title">Locale</label>
      <select id="selected_locale" v-model="selectedLocale">
        <option v-for="key in Object.keys(locales)" :key="key" :value="key">{{ key }}</option>
      </select>
    </div>
    <div class="_filters__section">
      <label for="selected_locale" class="_filters__section__title">Filter <small>(key or value)</small></label>
      <rui-search-form v-model="search" placeholder="Case sensitive search" />
    </div>
  </div>

  <table>
    <thead>
      <tr>
        <th>Key</th>
        <th>Value</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="key in Object.keys(list).sort()" :key="key">
        <td>
          <span class="-inline-flex -gap">
            <doc-copy-to-clipboard :content="key" class="rui-button--small" />
            <code>{{ key }}</code>
          </span>
        </td>
        <td>{{ locales[selectedLocale][key] }}</td>
      </tr>
    </tbody>
  </table>
</template>

<script>
import DocCopyToClipboard from '@experiments-labs/rise_ui/documentation_system/components/CopyToClipboard/CopyToClipboard.vue'
import RuiSearchForm from '@experiments-labs/rise_ui/src/components/Form/SearchForm.vue'

import { flattenDict } from '@experiments-labs/rise_ui/documentation_system/utils/Object'

import enTranslations from '@/entrypoints/locales/en.json'
import frTranslations from '@/entrypoints/locales/fr.json'

export default {
  name: 'I18nView',
  components: { DocCopyToClipboard, RuiSearchForm },
  data () {
    return {
      tab: 'text',
      localesDisplay: 'table',
      locales: {
        en: flattenDict(enTranslations.en),
        fr: flattenDict(frTranslations.fr),
      },
      selectedLocale: 'en',
      search: '',
    }
  },
  computed: {
    list () {
      const list = this.locales[this.selectedLocale]
      if (this.search.length < 3) return list

      return Object.keys(list).reduce((hash, key) => {
        if (key.includes(this.search) || list[key]?.includes(this.search)) hash[key] = list[key]
        return hash
      }, {})
    },
  },
  created () {
    this.$setTitle('I18n')
  },
}
</script>
